<?php
/**
 * @package MAIL_LINK
 * @copyright Copyright (C) 2010 Majunke Michael <http://www.mmajunke.de>. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License, or (at your option)
 * any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see <http://www.gnu.org/licenses/>.
**/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport( 'joomla.filesystem.folder' );
jimport('joomla.filesystem.file');


/**
 * Controller
 */
class MaillinkAdminController extends JController {

    /**
     * Method to display the view
     *
     * @access public
     */
    function display()
    {

        //
        JToolBarHelper::title("com_maillink");

        //
        JToolBarHelper::preferences( 'com_maillink' , '350', '570' );

        parent::display();
    }

    function fileUpload(){

        $config		= &JComponentHelper::getParams( 'com_maillink' );
        $downloadRoot	= JPATH_SITE . DS . $config->get( 'folder' );
        $dest_Folder = $downloadRoot;

        //
        $file_perms = $config->get( 'fileperms' );

        // create Root
        if ( !JFolder::exists( $downloadRoot ) ) {
          if (JFolder::create( $downloadRoot, $file_perms ))
      		{
      			 @JFile::write( $downloadRoot . DS . "index.html", "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
      		}
      		else
      		{
      		  JError::raiseWarning(200, JText::_('CANT_CREATE_DOCUMENT_ROOT_FOLDER' ) ); // TODO Language
      		  JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
              parent::display();
              return;
      		}
        }

        // destination folder
        $param_dest_fileUpload = JRequest::getVar('dest_fileUpload', null, 'default', 'string', JREQUEST_ALLOWHTML);
        if ( empty($param_dest_fileUpload) ){
            JError::raiseWarning(200, JText::_('MISSING_DOCUMENT_FOLDER' ) ); // TODO Language
      		JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
            parent::display();
            return;
        }
        $param_dest_fileUpload = JFolder::makeSafe($param_dest_fileUpload);
        $dest_Folder = $dest_Folder . $param_dest_fileUpload;

        // new Folder
        // TODO extra task , z.B. leere Folder anlegen usw. ?
        $param_newFolder_fileUpload = JRequest::getString('newFolder_fileUpload' );
        if ( ! empty($param_newFolder_fileUpload) ){
            $param_newFolder_fileUpload = JFolder::makeSafe($param_newFolder_fileUpload);
            $dest_Folder = $dest_Folder . DS. $param_newFolder_fileUpload;
            if ( !JFolder::exists( $dest_Folder  ) ) {
              if (JFolder::create( $dest_Folder, $file_perms ))
          		{
          		    @JFile::write( $dest_Folder . DS . "index.html", "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
          		}
          		else
          		{
          		  JError::raiseWarning(200, JText::_('CANT_CREATE_FOLDER' ) ); // TODO Language
          		  JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
                parent::display();
                return;
          		}
            }
        }


        // uploaded file
        $param_data_fileUpload = JRequest::getVar('data_fileUpload', null, 'files', 'array');
        // Array ( [name] => a.zip [type] => application/zip
        //         [tmp_name] => /tmp/sdasf [error] => 0 [size] => 4463 )
        if(isset($param_data_fileUpload)){

                //
                $param_data_fileUpload_filename = JFile::makeSafe($param_data_fileUpload['name']);

                $src = $param_data_fileUpload['tmp_name'];
                $dest = $dest_Folder . DS . $param_data_fileUpload_filename;

				//
				if ( 'index.html' === strtolower(JFile::getName($dest)) ) {
					JError::raiseWarning(200, JText::_('INVALID_FILE_TYPE' ) ); // TODO Language
		          	JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
		            parent::display();
		            return;
				}

				// check File has the right extension
				$types_Type_str = $config->get( 'filtertypes_type' );
				$types_str = $config->get( 'filtertypes' );
				if ( $types_Type_str != '1' ) {
					// WhiteList ( erlaube nur diese )
					if ( !empty($types_str)) {
						$types = explode(";" , $types_str );
						if ( !empty($types)) {
							if ( ! in_array( strtolower(JFile::getExt($dest)) , $types ) ) {
			                  JError::raiseWarning(200, JText::_('INVALID_FILE_TYPE' ) ); // TODO Language
			          		  JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
			                  parent::display();
			                  return;
							}
						}
					}
				}
				else {
					// BlackList ( verbiete Typen )
					if ( !empty($types_str)) {
						$types = explode(";" , $types_str );
						if ( !empty($types)) {
							if ( in_array( strtolower(JFile::getExt($dest)) , $types ) ) {
			                  JError::raiseWarning(200, JText::_('INVALID_FILE_TYPE' ) ); // TODO Language
			          		  JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
			                  parent::display();
			                  return;
							}
						}
					}
				}

				// first Del
				if ( JFile::exists($dest) ) {
					JFile::delete($dest);
				}

				// now Upload
                if ( JFile::upload($src, $dest ) ) {
                  //
                  // JError::raiseNotice( 0, JText::_('UPLOADED_TO').': '. $dest );
                  JRequest::setVar('view', 'filebrowser'); // force the view
                  parent::display();
                  return;

                } else {
                  //
                  JError::raiseWarning(200, JText::_('CANT_SAVE_FILE' ) ); // TODO Language
          		    JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
                  parent::display();
                  return;
                }
        }
        else {
            JError::raiseWarning(200, JText::_('MISSING_FILE_DATA' ) ); // TODO Language
    		    JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
            parent::display();
            return;
        }


    }

	function fileDel(){

        $config		= &JComponentHelper::getParams( 'com_maillink' );
        $downloadRoot	= JPATH_SITE . DS . $config->get( 'folder' );

        // create Root
        if ( !JFolder::exists( $downloadRoot ) ) {
  		  JError::raiseWarning(200, JText::_('DOCUMENT_ROOT_FOLDER_NOT_EXIST') ); // TODO Language
  		  JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
          parent::display();
	      return;
        }

        // destination folder
        $param_file = JRequest::getVar('dest_fileDel', null, 'default', 'string', JREQUEST_ALLOWHTML);
        if ( empty($param_file) ){
            JError::raiseWarning(200, JText::_('MISSING_FILE' ) ); // TODO Language
      		JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
            parent::display();
            return;
        }

        //
        $param_file_u = JFile::getName( $param_file  );
        $param_file_u  = JFile::makeSafe( $param_file_u );

        // JFolder::files($path, $filter = '.', $recurse, $fullpath , $exclude);
        $fileToSearch_arr = JFolder::files( $downloadRoot , $param_file_u, true, true );

		if ( empty($fileToSearch_arr) ) {
            JError::raiseWarning(201, JText::_('FILE_NOT_EXIST ' . $param_file_u) ); // TODO Language
            JRequest::setVar('view', 'filebrowser');
            parent::display();
            return;
        }

        // gleiche Namen in recursive folders
        // suche..
        $fileToDel = '';
        if ( count($fileToSearch_arr) > 0 ){
          foreach( $fileToSearch_arr as $sf ){
            $tocmp = '';
            if ( strncmp ( $param_file , DS , 1 ) == 0 ) {
              $tocmp = $downloadRoot . $param_file;
            }
            else {
              $tocmp = $downloadRoot . DS . $param_file;
            }
            if ( strcmp($sf ,  $tocmp ) == 0 ){
              $fileToDel = $sf;
              break;
            }
          }
        }

        if ( empty($fileToDel) ) {
			JError::raiseWarning(200, JText::_('FILE_NOT_FOUND' ) ); // TODO Language
          	JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
            parent::display();
            return;
        }

		//
		if ( JFile::exists($fileToDel) ) {
			JFile::delete($fileToDel);
		}

		JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
        parent::display();
        return;

	}

    function filebrowser() {

        //
        $config		= &JComponentHelper::getParams( 'com_maillink' );
        $downloadRoot	= JPATH_SITE . DS . $config->get( 'folder' );

        if ( !JFolder::exists( $downloadRoot ) ) {
            JError::raiseWarning(200, JText::_('DOCUMENT_ROOT_FOLDER_NOT_EXIST' ) ); // TODO Language
            // JRequest::setVar('tmpl', 'component'); // force the component template - plugin, better for reuse
            JRequest::setVar('view', 'filebrowser'); //force the view TODO error page ?
            parent::display();
            return;
        }

        // JRequest::setVar('tmpl', 'component'); // force the component template - plugin, better for reuse
        JRequest::setVar('view', 'filebrowser'); // force the view
        parent::display();
    }

}
?>